function theoryline(x1, x2, y1, y2){
this.x1=x1;this.x2=x2;this.y1=y1;this.y2=y2;
}

function theorypoint(x, y){
this.x=x; this.y=y;
}


function accDist(a, b){
return Math.sqrt(((a.x-b.x)*(a.x-b.x))+((a.y-b.y)*(a.y-b.y)))
}

function drawCracks(image){
return
var i = image.width+1;
while(i<(image.width-2)*(image.height-2)){
var pxloc = new theorypoint(Math.max(Math.min(i%image.width, image.width-2), 2), Math.min(Math.random()*image.height, image.height-2))
var color = image.getPixel(pxloc.x, pxloc.y);
color = CreateColor(color.red-10, color.green-10, color.blue-10, color.alpha); 
var ncolor = CreateColor(0,0,0,255);
for(var x = -1; x<2; x++){
	for(var y = -1; y<2; y++){
		color = BlendColorsWeighted(color, image.getPixel(Math.max(pxloc.x+x, 0), Math.max(pxloc.y+y, 0)), 12, 2)
	}
}
image.setPixel(pxloc.x, pxloc.y, color);
i++ 
i+=Math.floor(Math.random()*32)
}
}

function drawAltCracks(image){
return
var controlimage = image.clone();
var controlcolor = image.getPixel(Math.floor(image.width/2), Math.floor(image.height/2));
	for(var x = 2; x<image.width-2; x++){
		for(var y = 2; y<image.height-2; y+=Math.random()*8){
		if(Math.random()>0.9) continue;
		
		var chanceToCrack = 0.05
		
			for(var i = -1; i<2; i++){
				for(var e = -1; e<2; e++){
				var pxcolor = controlimage.getPixel(x+i, y+e)
					if(isDarker(pxcolor, controlcolor, false)){chanceToCrack+=0.4}
				}
			}
			
	
		if(Math.random()<chanceToCrack)
			{
			var dir = Math.floor(Math.random()*8)*Math.PI/4
			var color = image.getPixel(x, y);
			var length = Math.random()*8
			color = BlendColors(CreateColor(color.red/1.5, color.green/1.5, color.blue/1.5, color.alpha), color);
			if(Math.random()>0.8)image.line(x+Math.cos(dir)*length, y+Math.sin(dir)*length, x-Math.cos(dir)*length, y-Math.sin(dir)*length, color)
			color = BlendColors(CreateColor(color.red/2, color.green/2, color.blue/2, color.alpha), color);
			image.setPixel(x, y, color)
			}
			/*{
			var color = image.getPixel(x, y);
			color = BlendColors(CreateColor(color.red/3, color.green/3, color.blue/3, color.alpha), color);
			image.setPixel(x, y, color)
			}*/
		}
	}
}

function isDarker(c1, c2, alpha){
var c1total = c1.red+c1.green+c1.blue+(alpha?c1.alpha:0);
var c2total = c2.red+c2.green+c2.blue+(alpha?c2.alpha:0);
return c1total<c2total
}

function LoadLevel(filename){
blocks = [];
drops = [];
balls = [];
reload();
var file = OpenFile(filename+".LVL")
var numblocks = file.read("numblocks", 0);
var i = 0;
	while(i<numblocks){
	//block(x, y, hp, drop, imageorheight, width, color)
	var bx 			= file.read("block"+i+"x", 1);
	var by 			= file.read("block"+i+"y", 1);
	var bhp			= file.read("block"+i+"hp", 0);
	var isimage	= file.read("block"+i+"isim", 1);
	
	var imh;
	var drops = file.read("block"+i+"drop", 0)
	if(drops==0) {drops=false}
	else {
	var dtype = file.read("block"+i+"dtype", "slow")
	switch(dtype){
	case "slow":
	var deffect = decrementballspeed;
	break;
	case "fast":
	var deffect = incrementballspeed;
	break;
	case "unst":
	var deffect = makeballunstoppable;
	break;
	case "addb":
	var deffect = addnewball;
	break;
	
	
	}
	var indrop = new drop(bx+32, by+8, 1, LoadImage(file.read("block"+i+"dropim", "bluepowerup")+".tga"),deffect)
	
	}
	if(isimage==1){
		imh = file.read("block"+i+"im", "redblock")+".tga"
		blocks.push(new block(bx, by, bhp, drops?indrop:drops, imh))
	}
	else{				
		imh	=	file.read("block"+i+"h", 10)
		w	=	file.read("block"+i+"w", 0)
		color = CreateColor(file.read("block"+i+"r", 0), file.read("block"+i+"g", 0), file.read("block"+i+"b", 0), file.read("block"+i+"a", 0))
		blocks.push(new block(bx, by, bhp, drops?indrop:drops, imh, w, color))
	}
	i++
	}
file.close();
CleanUpBlocks();
}

function getAngle(a, b){
return Math.atan2(a.y-b.y, a.x-b.x)
}
var TLstrings = ["Play The Game!", "Level Select", "Level Editor"];
var TLcur = 0;
var TLcurleft = LoadImage("curleft.tga");
var TLcurright = LoadImage("curright.tga");
function titlescreen(){
while(AreKeysLeft()){GetKey();}
var end = false
balls.push(new ball(GetScreenWidth()/2, GetScreenHeight()/2, Math.random()*2*Math.PI, 8-Math.random(), 0, 16, White))
balls.push(new ball(GetScreenWidth()/2, GetScreenHeight()/2, Math.random()*2*Math.PI, 8-Math.random(), 0, 16, White))
balls.push(new ball(GetScreenWidth()/2, GetScreenHeight()/2, Math.random()*2*Math.PI, 8-Math.random(), 0, 16, White))

while(!end){

processBalls(true);
Rectangle(0,0,GetScreenWidth(), 32, Blue)
OutlinedRectangle(2, 2, GetScreenWidth()-3, 29, CreateColor(100,100,100,200))
OutlinedRectangle(1, 1, GetScreenWidth()-3, 29, CreateColor(200,200,200,200))
Line(0, 32, GetScreenWidth(), 32, CreateColor(200,200,200,200))
Line(0, 33, GetScreenWidth(), 33, CreateColor(100,100,100,200))

Rectangle(0,GetScreenHeight()-32,GetScreenWidth(), 32, Blue)
OutlinedRectangle(2, GetScreenHeight()-30, GetScreenWidth()-3, 29, CreateColor(100,100,100,200))
OutlinedRectangle(1, GetScreenHeight()-31, GetScreenWidth()-3, 29, CreateColor(200,200,200,200))
Line(0, GetScreenHeight()-34, GetScreenWidth(), GetScreenHeight()-34, CreateColor(200,200,200,200))
Line(0, GetScreenHeight()-33, GetScreenWidth(), GetScreenHeight()-33, CreateColor(100,100,100,200))

for(var i = 0; i<TLstrings.length; i++){
font2.drawText(1+(GetScreenWidth()/2)-(font.getStringWidth(TLstrings[i])/2),-35+(i*15)+1+GetScreenHeight()/2,  TLstrings[i])
font.drawText((GetScreenWidth()/2)-(font.getStringWidth(TLstrings[i])/2),-35+(i*15)+GetScreenHeight()/2,  TLstrings[i])
	if(TLcur==i){
	TLcurleft.blit(	(GetScreenWidth()/2)-TLcurleft.width-font.getStringWidth(TLstrings[i]+"  ")/2, -38+(i*15)+GetScreenHeight()/2);
	TLcurright.blit((GetScreenWidth()/2)+font.getStringWidth(TLstrings[i]+"  ")/2, -38+(i*15)+GetScreenHeight()/2);
	
	
	}
}
if(IsKeyPressed(KEY_DOWN)){
if(!TLdownWD){
TLcur++;
TLcur%=TLstrings.length;
TLdownWD=true;}
}
else {TLdownWD=false}

if(IsKeyPressed(KEY_UP)){
if(!TLupWD){
TLcur--;
if(TLcur<0)TLcur=TLstrings.length-1;
TLupWD=true;}
}
else {TLupWD=false}
font2.drawText(8, GetScreenHeight()-22, "2012        Flying Jester Entertainment        Powered by Sphere        Version 0.66")
font.drawText(7, GetScreenHeight()-23, "2012        Flying Jester Entertainment        Powered by Sphere        Version 0.66")

font2.drawText(101, 11, "            Version 0.66           ")
font.drawText(100, 10, "            Version 0.66           ")

font2.drawZoomedText(112, 78, 2.3, "Jester's Breakout")
font.drawZoomedText(110, 76, 2.3, "Jester's Breakout")
FlipScreen();
//while(AreKeysLeft()){GetKey(); end = true}
//while(IsAnyKeyPressed()){}
if(IsKeyPressed(KEY_ENTER)){
while(AreKeysLeft()){GetKey()}
while(IsAnyKeyPressed()){}
	switch(TLcur){
	case 0:
	end=true;
	break;
	case 1:
	break;
	case 2:
	Editor();
	break;
	}
}
}

}